


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""

  InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

    do_click

}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 1

    variable LogText ""
    variable LogFlag 1
    variable LogCount 0

    variable JS ""

    variable Temps
    variable C
    variable S

    set Temps {0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0}
    for {set i 0} {$i < 10} {incr i} {set C($i) -1}
    for {set i 0} {$i < 10} {incr i} {set S($i) -1}
    set C(Time) "[clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
    set S(Time) "[clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"

    variable ST
    variable SLow
    variable SHigh

    set ST(0) "Seg1 Virtex"
    set SLow(0) 20
    set SHigh(0) 40

    set ST(1) "Seg1 Analog"
    set SLow(1) 20
    set SHigh(1) 40

    set ST(2) "Seg2 Virtex"
    set SLow(2) 20
    set SHigh(2) 40

    set ST(3) "Seg2 Analog"
    set SLow(3) 20
    set SHigh(3) 40

    set ST(4) "Seg3 Virtex"
    set SLow(4) 20
    set SHigh(4) 40

    set ST(5) "Seg3 Analog"
    set SLow(5) 20
    set SHigh(5) 40

    set ST(6) "Seg4 Virtex"
    set SLow(6) 20
    set SHigh(6) 40

    set ST(7) "Seg4 Analog"
    set SLow(7) 20
    set SHigh(7) 40

    set ST(8) "PSU 1"
    set SLow(8) 20
    set SHigh(8) 35

    set ST(9) "PSU 2"
    set SLow(9) 20
    set SHigh(9) 35

    set CT(0) "Seg1 Virtex"
    set CLow(0) 20
    set CHigh(0) 40

    set CT(1) "Seg1 Analog"
    set CLow(1) 20
    set CHigh(1) 40

    set CT(2) "Seg2 Virtex"
    set CLow(2) 20
    set CHigh(2) 40

    set CT(3) "Seg2 Analog"
    set CLow(3) 20
    set CHigh(3) 40

    set CT(4) "Core Virtex"
    set CLow(4) 20
    set CHigh(4) 40

    set CT(5) "Core Analog"
    set CLow(5) 20
    set CHigh(5) 40

    set CT(6) "PSU 1"
    set CLow(6) 20
    set CHigh(6) 35

    set CT(7) "PSU 2"
    set CLow(7) 20
    set CHigh(7) 35

    set CT(8) "PSU 3"
    set CLow(8) 20
    set CHigh(8) 35

    source Global.tcl

    proc read_temperatures {which}  {
        variable ::AGATADigitizer::Digitizer 
        variable Temps 
        variable C
        variable S 
        global errorCode errorInfo

        if {$which == "C"} {set fpga 3}   ;# select main board
        if {$which == "S"} {set fpga 12}   ;# select main board

        set Cmd 19       ;#   Use command 19 
        set Length 20    ;#   which returns 20 bytes of result

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Read $Digitizer $fpga $Cmd A16 $Length} m]
        if {$rc != 0} {
            InsertLog "Read temperatures returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            set Temps $m
            if {[llength $Temps] < 20} {
                InsertLog "Read temperatures returned with invalid response: $Temps"
                return -1
            }
        }

        for {set i 0; set j 0} {$i < 20} {incr i; incr j} {
           set msb [lindex $Temps $i]
           incr i
           set lsb [lindex $Temps $i]
           if {$fpga < 8} {
               set T [expr (((($msb * 255) + $lsb)/8) & 0x0fff) * 0.0625]
               if {$msb >= 128} then {
                  set C($j) [expr $T * -1.0]
               } else {
                  set C($j) $T
               }
               set C($j) [format "%-4.1f" $C($j)]
           } else {
               set T [expr (((($msb * 255) + $lsb)/8) & 0x0fff) * 0.0625]
               if {$msb >= 128} then {
                  set S($j) [expr $T * -1.0]
               } else {
                  set S($j) $T 
               }
               set S($j) [format "%-4.1f" $S($j)]
           }
        }
    }

   proc get_temperatures {} {
      variable Temps
      variable C
      variable S

      variable ::AGATADigitizer::CorePresent
      variable ::AGATADigitizer::SegmentPresent

       set C(Time) "[clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
       set S(Time) "[clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"
       if {$CorePresent == 1} {read_temperatures C}
       if {$SegmentPresent == 1} {read_temperatures S}

   }

   proc  show_variables {} {
        variable LogText
        variable ShowLogFlag
        variable ::AGATADigitizer::Digitizer

         if {$ShowLogFlag == 1} {
             set LogText ""
             InsertLog "Digitizer=$Digitizer"
         }  else {
             append JS "alert(\"Digitizer=$Digitizer\");"
         }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogText
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

#      InsertLog "cgidata= ([llength $cgidata]) $cgidata"

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
          InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {
           switch -glob [lindex $cgidata 1] {

               TEMPUPDATE {get_temperatures; return}

                RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}

                MainLog   {}
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}

            }
         }
      }
   }

   get_temperatures

}   ;# end of if {$started == 0} 


